groff-commit
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

[groff] 04/06: Add man page header/footer regression tests.


From: G. Branden Robinson
Subject: [groff] 04/06: Add man page header/footer regression tests.
Date: Sat, 15 May 2021 20:47:22 -0400 (EDT)

gbranden pushed a commit to branch master
in repository groff.

commit 9f7e3591a772c33dba9973cdd67d1d60ad0de349
Author: G. Branden Robinson <g.branden.robinson@gmail.com>
AuthorDate: Sun May 16 10:30:17 2021 +1000

    Add man page header/footer regression tests.
---
 ChangeLog                                         |  6 ++
 tmac/tests/an-old_page-footers-present.sh         | 68 ++++++++++++++++++++++
 tmac/tests/an-old_page-header-has-current-data.sh | 70 +++++++++++++++++++++++
 tmac/tmac.am                                      |  2 +
 4 files changed, 146 insertions(+)

diff --git a/ChangeLog b/ChangeLog
index d6ee4f7..915a6c8 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,9 @@
+2021-05-16  G. Branden Robinson <g.branden.robinson@gmail.com>
+
+       * tmac/tests/an-old_page-footers-present.sh:
+       * tmac/tests/an-old_page-header-has-current-data.sh: Add man
+       page header/footer regression tests.
+
 2021-05-15  G. Branden Robinson <g.branden.robinson@gmail.com>
 
        * tmac/an-old.tmac (initialization): Key the reprocessing guard
diff --git a/tmac/tests/an-old_page-footers-present.sh 
b/tmac/tests/an-old_page-footers-present.sh
new file mode 100755
index 0000000..2ce1650
--- /dev/null
+++ b/tmac/tests/an-old_page-footers-present.sh
@@ -0,0 +1,68 @@
+#!/bin/sh
+#
+# Copyright (C) 2021 Free Software Foundation, Inc.
+#
+# This file is part of groff.
+#
+# groff is free software; you can redistribute it and/or modify it under
+# the terms of the GNU General Public License as published by the Free
+# Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# groff is distributed in the hope that it will be useful, but WITHOUT ANY
+# WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+# for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+#
+
+groff="${abs_top_builddir:-.}/test-groff"
+
+# Regression-test Savannah #60609.
+
+INPUT='.TH foo 1 2021-05-16 "groff test suite" "Volume 1"
+.SH Name
+foo \- a frobnicating thing
+.TH bar 1 2021-05-16 "groff test suite" "Volume 2"
+.SH Name
+bar \- a wretched hive of scum and villainy'
+
+OUTPUT=$(echo "$INPUT" | "$groff" -Tascii -P-cbou -man)
+
+FAIL=
+
+if ! echo "$OUTPUT" | grep -Eqx 'groff test suite +2021-05-16 +foo\(1\)'
+then
+    FAIL=yes
+    echo "first page footer test failed (continuous rendering on)" >&2
+fi
+
+if ! echo "$OUTPUT" | grep -Eqx 'groff test suite +2021-05-16 +bar\(1\)'
+then
+    FAIL=yes
+    echo "second page footer test failed (continuous rendering on)" >&2
+fi
+
+OUTPUT=$(echo "$INPUT" | "$groff" -Tascii -P-cbou -man -rcR=0)
+
+if ! echo "$OUTPUT" | grep -Eqx 'groff test suite +2021-05-16 +1'
+then
+    FAIL=yes
+    echo "first page footer test failed (continuous rendering off)" >&2
+fi
+
+OUTPUT=$(echo "$INPUT" | "$groff" -Tascii -P-cbou -man -rcR=0 -rC1)
+
+if ! echo "$OUTPUT" | sed '1,/^groff test suite/d' \
+    | grep -Eqx 'groff test suite +2021-05-16 +2'
+then
+    FAIL=yes
+    echo "second page footer test failed (continuous rendering off," \
+        " cotinuous numbering on)" >&2
+fi
+
+test -z "$FAIL"
+
+# vim:set ai et sw=4 ts=4 tw=80:
diff --git a/tmac/tests/an-old_page-header-has-current-data.sh 
b/tmac/tests/an-old_page-header-has-current-data.sh
new file mode 100755
index 0000000..90e3b59
--- /dev/null
+++ b/tmac/tests/an-old_page-header-has-current-data.sh
@@ -0,0 +1,70 @@
+#!/bin/sh
+#
+# Copyright (C) 2021 Free Software Foundation, Inc.
+#
+# This file is part of groff.
+#
+# groff is free software; you can redistribute it and/or modify it under
+# the terms of the GNU General Public License as published by the Free
+# Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# groff is distributed in the hope that it will be useful, but WITHOUT ANY
+# WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+# for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+#
+
+groff="${abs_top_builddir:-.}/test-groff"
+
+# Misconfiguration of traps or our man(7) implementation's page-flushing 
macros,
+# or poor ordering of logic in its TH macro, can cause page headers to render
+# with incorrect information.
+
+INPUT='.TH foo 1 2021-05-16 "groff test suite" "Volume 1"
+.SH Name
+foo \- a frobnicating thing
+.TH bar 1 2021-05-16 "groff test suite" "Volume 2"
+.SH Name
+bar \- a wretched hive of scum and villainy'
+
+OUTPUT=$(echo "$INPUT" | "$groff" -Tascii -P-cbou -man)
+echo "$OUTPUT"
+
+FAIL=
+
+if ! echo "$OUTPUT" | grep -Eqx 'foo\(1\) +Volume 1 +foo\(1\)'
+then
+    FAIL=yes
+    echo "first page header test failed (continuous rendering on)" >&2
+fi
+
+if ! echo "$OUTPUT" | sed '1,/^groff test suite/d' \
+    | grep -Eqx 'bar\(1\) +Volume 2 +bar\(1\)'
+then
+    FAIL=yes
+    echo "second page header test failed (continuous rendering on)" >&2
+fi
+
+OUTPUT=$(echo "$INPUT" | "$groff" -Tascii -P-cbou -man -rcR=0)
+echo "$OUTPUT"
+
+if ! echo "$OUTPUT" | grep -Eqx 'foo\(1\) +Volume 1 +foo\(1\)'
+then
+    FAIL=yes
+    echo "first page header test failed (continuous rendering off)" >&2
+fi
+
+if ! echo "$OUTPUT" | sed '1,/^groff test suite/d' \
+    | grep -Eqx 'bar\(1\) +Volume 2 +bar\(1\)'
+then
+    FAIL=yes
+    echo "second page header test failed (continuous rendering off)" >&2
+fi
+
+test -z "$FAIL"
+
+# vim:set ai et sw=4 ts=4 tw=80:
diff --git a/tmac/tmac.am b/tmac/tmac.am
index 5c92b84..89bff6e 100644
--- a/tmac/tmac.am
+++ b/tmac/tmac.am
@@ -172,6 +172,8 @@ tmac_TESTS = \
   tmac/tests/an-old_TS-do-not-keep-tables-when-cR-set.sh \
   tmac/tests/an-old_X-register-works.sh \
   tmac/tests/an-old_avoid-two-font-denial-of-service.sh \
+  tmac/tests/an-old_page-footers-present.sh \
+  tmac/tests/an-old_page-header-has-current-data.sh \
   tmac/tests/andoc_clear-doc-traps.sh \
   tmac/tests/andoc_flush-between-packages.sh \
   tmac/tests/doc_CS-works.sh \



reply via email to

[Prev in Thread] Current Thread [Next in Thread]